=== modified file 'src/com/goldencode/p2j/persist/DataSet.java'
--- old/src/com/goldencode/p2j/persist/DataSet.java	2022-04-22 22:17:35 +0000
+++ new/src/com/goldencode/p2j/persist/DataSet.java	2022-05-12 15:03:49 +0000
@@ -62,6 +62,8 @@
 **     CA  20220106 Fixed CREATE-LIKE when relations are involved, their active flag was not being copied 
 **                  properly.
 **     OM  20220422 Allow Xml/JsonImport to load records into buffer without exposing package private methods.
+**     GES 20210501 Upgraded dataset parameter processing to match API changes. Reworked associate() and
+**                  createDynamicDataSet() to remove unnecessary arguments.
 */
 
 /*
@@ -326,88 +328,88 @@
     *
     * @see TemporaryBuffer#associate(TableParameter, Temporary, boolean, boolean)
     */
-   public static void associate(final DataSetParameter dsLocal,
-                                final DataSet dsTarget,
-                                boolean input,
-                                boolean output)
-   {
-      associate(dsLocal, dsTarget, input, output, false, ParameterOption.NONE);
-   }
-   
-   /**
-    * Associate two {@code DataSet} with one another, such that all relevant records can be copied
-    * between them at prescribed times.
-    * 
-    * @param   dsSrc
-    *          The local object relative to the current procedure. If this is an INPUT parameter
-    *          then this is the 'source'. This encapsulates the actual parameter sent by caller.
-    * @param   dsTarget
-    *          A dataset defined in current external procedure. 
-    * @param   input
-    *          If {@code true}, records are copied from source table to destination table
-    *          immediately upon invocation of this method, otherwise they are not.
-    * @param   output
-    *          When {@code true}, the records are copied from destination table back to source
-    *          table when the current transaction or subtransaction is committed;  otherwise they
-    *          are not.
-    * @param   append
-    *          Use {@code true} to add new records without affecting existing records.<br>
-    *          Use {@code false} to remove all existing records before the copy takes place. This
-    *          option affects the {@code input} copy only, not the {@code output} copy.
-    * 
-    * @see TemporaryBuffer#associate(TableParameter, Temporary, boolean, boolean) 
-    */
-   public static void associate(final DataSetParameter dsSrc,
-                                final DataSet dsTarget,
-                                boolean input,
-                                boolean output,
-                                boolean append)
-   {
-      associate(dsSrc, dsTarget, input, output, append, null);
-   }
-   
-   /**
-    * Associate two {@code DataSet} with one another, such that all relevant records can be copied
-    * between them at prescribed times.
-    * 
-    * @param   dsSrc
-    *          The local object relative to the current procedure. If this is an INPUT parameter
-    *          then this is the 'source'. This encapsulates the actual parameter sent by caller.
-    * @param   dsTarget
-    *          A dataset defined in current external procedure. 
-    * @param   input
-    *          If {@code true}, records are copied from source table to destination table
-    *          immediately upon invocation of this method, otherwise they are not.
-    * @param   output
-    *          When {@code true}, the records are copied from destination table back to source
-    *          table when the current transaction or subtransaction is committed;  otherwise they
-    *          are not.
-    * @param   append
-    *          Use {@code true} to add new records without affecting existing records.<br>
-    *          Use {@code false} to remove all existing records before the copy takes place. This
-    *          option affects the {@code input} copy only, not the {@code output} copy.
-    * @param   mode
-    *          Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option.
+   public static void associate(DataSetParameter dsLocal, DataSet dsTarget, boolean input, boolean output)
+   {
+      associate(dsLocal, dsTarget, input, output, ParameterOption.NONE);
+   }
+   
+   /**
+    * Associate two {@code DataSet} with one another, such that all relevant records can be copied
+    * between them at prescribed times.
+    * 
+    * @param   dsSrc
+    *          The local object relative to the current procedure. If this is an INPUT parameter
+    *          then this is the 'source'. This encapsulates the actual parameter sent by caller.
+    * @param   dsTarget
+    *          A dataset defined in current external procedure. 
+    * @param   input
+    *          If {@code true}, records are copied from source table to destination table
+    *          immediately upon invocation of this method, otherwise they are not.
+    * @param   output
+    *          When {@code true}, the records are copied from destination table back to source
+    *          table when the current transaction or subtransaction is committed;  otherwise they
+    *          are not.
+    * @param   option
+    *          Dataset parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
     * 
     * @see TemporaryBuffer#associate(TableParameter, Temporary, boolean, boolean)
     */
+   public static void associate(DataSetParameter dsSrc,
+                                DataSet          dsTarget,
+                                boolean          input,
+                                boolean          output,
+                                ParameterOption  option)
+   {
+      dsSrc.setInputMode(input);
+      dsSrc.setOutputMode(output);
+      
+      associate(dsSrc, dsTarget, option);
+   }
+
+   /**
+    * Associate two {@code DataSet} with one another, such that all relevant records can be copied
+    * between them at prescribed times.
+    *
+    * @param   dsLocal
+    *          The local object relative to the current procedure. If this is an INPUT parameter
+    *          then this is the 'source'. This encapsulates the actual parameter sent by caller.
+    * @param   dsTarget
+    *          A dataset defined in current external procedure. 
+    *
+    * @see TemporaryBuffer#associate(TableParameter, Temporary)
+    */
+   public static void associate(DataSetParameter dsLocal, DataSet dsTarget)
+   {
+      associate(dsLocal, dsTarget, ParameterOption.NONE);
+   }
+   
+   /**
+    * Associate two {@code DataSet} with one another, such that all relevant records can be copied
+    * between them at prescribed times.
+    * 
+    * @param   dsSrc
+    *          The local object relative to the current procedure. If this is an INPUT parameter
+    *          then this is the 'source'. This encapsulates the actual parameter sent by caller.
+    * @param   dsTarget
+    *          A dataset defined in current external procedure. 
+    * @param   option
+    *          Dataset parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    * 
+    * @see TemporaryBuffer#associate(TableParameter, Temporary)
+    */
    public static void associate(final DataSetParameter dsSrc,
-                                final DataSet dsTarget,
-                                boolean input,
-                                boolean output,
-                                boolean append,
-                                ParameterOption mode)
+                                final DataSet          dsTarget,
+                                ParameterOption        option)
    {
-      if (!(input || output))
-      {
-         throw new IllegalStateException("Parameter mode (INPUT/OUTPUT) was not specified!");
-      }
+      boolean input  = dsSrc.isInputMode();
+      boolean output = dsSrc.isOutputMode();
+      boolean append = (option == ParameterOption.APPEND);
       
       StaticDataSet localDS = (StaticDataSet) dsTarget;
       if (!dsSrc.isRemoteParameter())
       {
-         DataSet sourceDS = dsSrc.getOriginalDataSet();
-         if (dsSrc.isBind() && mode == ParameterOption.BIND && 
+         DataSet sourceDS = (DataSet) dsSrc.getOriginalDataSet();
+         if (dsSrc.isBind() && option == ParameterOption.BIND && 
              sourceDS != null && !localDS.isReferenceOnly())
          {
             if (sourceDS.isReferenceOnly())
@@ -424,11 +426,11 @@
          }
          if (localDS.isReferenceOnly())
          {
-            if (dsSrc.isByReference() || dsSrc.isBind() || mode == ParameterOption.BIND)
+            if (dsSrc.isByReference() || dsSrc.isBind() || option == ParameterOption.BIND)
             {
                // temporary bind dsSrc.getDataset() to dsTarget
                localDS.bind(dsSrc.getDataset(), input, output, 
-                            dsSrc.isBind() || mode == ParameterOption.BIND);
+                            dsSrc.isBind() || option == ParameterOption.BIND);
                {
                   // TODO: check for both usages of [bind] what happens if the check fails for a
                   //       subsequent parameter in case there are many DataSet: roll back the
@@ -481,7 +483,7 @@
          }
          // NONE to BIND will do nothing, unless the REFERENCE-ONLY is used at target
          // BIND to NONE will error out
-         else if (dsSrc.isBind() && mode == ParameterOption.NONE)
+         else if (dsSrc.isBind() && option == ParameterOption.NONE)
          {
             ErrorManager.recordOrThrowError(13009, "BIND failed TODO: correct msg");
             return;
@@ -586,22 +588,39 @@
     * a method/function in order to properly convert the {@code PARAMETER DATASET-HANDLE}
     * constructs.
     *
-    * @param   dsParam
-    *          The {@code DataSetParameter}. This is the actual parameter for the routine.
-    * @param   dsHandle
-    *          A handle to store the reference to the new {@code DataSet} during the scope of this
-    *          routine.
-    * @param   input
-    *          If {@code true} then this is an {@code INPUT} or {@code INPUT-OUTPUT} parameter.
-    * @param   output
-    *          If {@code true} then this is an {@code OUTPUT} or {@code INPUT-OUTPUT} parameter.
+    * @param    dsParam
+    *           The {@code DataSetParameter}. This is the actual parameter for the routine.
+    * @param    dsHandle
+    *           A handle to store the reference to the new {@code DataSet} during the scope of this
+    *           routine.
+    */
+   public static void createDynamicDataSet(DataSetParameter dsParam, handle dsHandle)
+   {
+      createDynamicDataSet(dsParam, dsHandle, ParameterOption.NONE);
+   }
+   
+   /**
+    * Dynamically create a {@code DataSet} from the {@code DataSetParameter} provided. The new
+    * {@code DataSet} will be stored in {@code dsHandle}. This method is used at the beginning of
+    * a method/function in order to properly convert the {@code PARAMETER DATASET-HANDLE}
+    * constructs.
+    *
+    * @param    dsParam
+    *           The {@code DataSetParameter}. This is the actual parameter for the routine.
+    * @param    dsHandle
+    *           A handle to store the reference to the new {@code DataSet} during the scope of this
+    *           routine.
+    * @param    input
+    *           If {@code true} then this is an {@code INPUT} or {@code INPUT-OUTPUT} parameter.
+    * @param    output
+    *           If {@code true} then this is an {@code OUTPUT} or {@code INPUT-OUTPUT} parameter.
     */
    public static void createDynamicDataSet(DataSetParameter dsParam,
-                                           handle dsHandle,
-                                           boolean input,
-                                           boolean output)
+                                           handle           dsHandle,
+                                           boolean          input,
+                                           boolean          output)
    {
-      createDynamicDataSet(dsParam, dsHandle, input, output, false, ParameterOption.NONE);
+      createDynamicDataSet(dsParam, dsHandle, input, output, ParameterOption.NONE);
    }
    
    /**
@@ -619,25 +638,43 @@
     *          If {@code true} then this is an {@code INPUT} or {@code INPUT-OUTPUT} parameter.
     * @param   output
     *          If {@code true} then this is an {@code OUTPUT} or {@code INPUT-OUTPUT} parameter.
-    * @param   append
-    *          {@code true} to add new records without affecting existing records;
-    *          {@code false} to remove all existing records before the copy takes place. This
-    *          option affects the {@code input} copy only, not the {@code output} copy.
-    * @param   mode
-    *          Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option.
+    * @param   option
+    *          Dataset parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
     */
    public static void createDynamicDataSet(DataSetParameter dsParam,
-                                           handle dsHandle,
-                                           boolean input,
-                                           boolean output,
-                                           boolean append,
-                                           ParameterOption mode)
+                                           handle           dsHandle,
+                                           boolean          input,
+                                           boolean          output,
+                                           ParameterOption  option)
    {
-      if (!(input || output))
-      {
-         throw new IllegalStateException("Parameter mode (INPUT/OUTPUT) was not specified!");
-      }
+      dsParam.setInputMode(input);
+      dsParam.setOutputMode(output);
       
+      createDynamicDataSet(dsParam, dsHandle, option);
+   }
+
+   /**
+    * Dynamically create a {@code DataSet} from the {@code DataSetParameter} provided. The new
+    * {@code DataSet} will be stored in {@code dsHandle}. This method is used at the beginning of
+    * a method/function in order to properly convert the {@code PARAMETER DATASET-HANDLE}
+    * constructs.
+    *
+    * @param   dsParam
+    *          The {@code DataSetParameter}. This is the actual parameter for the routine (src).
+    * @param   dsHandle
+    *          A handle to store the reference to the new {@code DataSet} during the scope of this
+    *          routine (target).
+    * @param   option
+    *          Dataset parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public static void createDynamicDataSet(DataSetParameter dsParam,
+                                           handle           dsHandle,
+                                           ParameterOption  option)
+   {
+      boolean input  = dsParam.isInputMode();
+      boolean output = dsParam.isOutputMode();
+      boolean append = (option == ParameterOption.APPEND);
+
       if (output)
       {
          TransactionManager.registerCurrent(dsHandle);
@@ -5468,7 +5505,7 @@
          
          SelfManager.pushSelf(self);
          // reference already assumes input-output, do not emit append
-         DataSetParameter dsp = new DataSetParameter(this, false, ParameterOption.BY_REFERENCE);
+         DataSetParameter dsp = new DataSetParameter(this, ParameterOption.BY_REFERENCE);
          if (cbd.getObject() != null)
          {
             // TODO:

=== modified file 'src/com/goldencode/p2j/persist/DataSetParameter.java'
--- old/src/com/goldencode/p2j/persist/DataSetParameter.java	2021-08-31 10:54:19 +0000
+++ new/src/com/goldencode/p2j/persist/DataSetParameter.java	2022-05-12 15:03:49 +0000
@@ -27,6 +27,7 @@
 **                  with no input data rows, which allows to access table structure if non-unknown
 **                  table/dataset handle has been passed from the calling side.
 **     CA  20210831 Fixed deserialization of a remote dataset which has data in the before-table(s).
+**     GES 20210501 Reworked to enable subclasses which reduce parameter processing from common use cases.
 */
 
 /*
@@ -89,21 +90,24 @@
 import java.util.*;
 
 /**
- * Container for DataSet reference/handle and calling-side APPEND option. Serves two purposes:
- *    1. passes calling-side APPEND option to the called side;
- *    2. implements interchangeability between DATASET and DATASET-HANDLE parameters (in 4GL you
- *       can pass DATASET parameter to a procedure that takes DATASET-HANDLE and vice versa).
+ * Represents a dataset or dataset-handle parameter, the mode (INPUT, INPUT-OUTPUT or OUTPUT) and any
+ * parameter options (APPEND, BY-VALUE, BIND or BY-REFERENCE).  Allows subclasses to specialize this
+ * behavior.  A core feature is to implement interchangeability between DATASET and DATASET-HANDLE parameters
+ * (in the 4GL you can pass a DATASET parameter to a procedure that takes DATASET-HANDLE and vice versa).
+ * <p>
+ * The parameter mode can be implemented in this class or it can be overridden in a subclass.  If it is
+ * implemented here, then the input and output flags must be passed to the constructor.  If the subclass
+ * overrides the {@link #isInputMode} and {@link #isOutputMode} methods then the input and output boolean
+ * members will be ignored.  This is sub-optimal but it was done deliberately to enable the base class to
+ * be used as a full replacement for any of the subclasses.
  */
 public class DataSetParameter
 {
    /** Reference of the wrapped dataset. */
    private final handle /*DataSet*/ dataset;
    
-   /** Corresponds calling-side APPEND option. */
-   private final boolean append;
-   
    /** Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option. */
-   private final ParameterOption mode;
+   private final ParameterOption option;
    
    /** Determines if this is a remote (passed to appserver) parameter. */
    private boolean remoteParameter = false;
@@ -123,6 +127,12 @@
 
    /** The original dataset passed as an argument. */
    private DataSet originalDataSet;
+
+   /** {@code true} if the parameter mode is INPUT or INPUT-OUTPUT. */   
+   private boolean input = false;   
+   
+   /** {@code true} if the parameter mode is OUTPUT or INPUT-OUTPUT. */
+   private boolean output = false;
    
    /**
     * Create a new parameter for the REMOTE dataset.
@@ -133,8 +143,7 @@
    public DataSetParameter(DatasetWrapper wrapper)
    {
       this.datasetWrapper = wrapper;
-      this.mode = ParameterOption.NONE;
-      this.append = wrapper.isAppend();
+      this.option = wrapper.isAppend() ? ParameterOption.APPEND : ParameterOption.NONE;
       this.remoteParameter = true;
       
       dataset = TypeFactory.handle();
@@ -152,7 +161,7 @@
     */
    public DataSetParameter(DataSetParameter dataset)
    {
-      this(dataset.getDataset(), false, ParameterOption.NONE);
+      this(dataset.getDataset(), ParameterOption.NONE);
    }
    
    /**
@@ -163,7 +172,7 @@
     */
    public DataSetParameter(DataSet dataset)
    {
-      this(dataset, false, ParameterOption.NONE);
+      this(dataset, ParameterOption.NONE);
    }
    
    /**
@@ -171,71 +180,77 @@
     *
     * @param   dataset
     *          Reference of the wrapped dataset.
-    * @param   append
-    *          Determines if APPEND option was specified on the calling side.
+    * @param   option
+    *          Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
     */
-   public DataSetParameter(DataSet dataset, boolean append)
+   public DataSetParameter(DataSet dataset, ParameterOption option)
    {
-      this(dataset, append, ParameterOption.NONE);
+      this(dataset, option, false, false);
    }
-   
+      
    /**
     * Create an instance using a dataset reference.
     *
-    * @param   dataset
-    *          Reference of the wrapped dataset.
-    * @param   append
-    *          Determines if APPEND option was specified on the calling side.
-    * @param   mode
-    *          Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option.
-    */
-   public DataSetParameter(DataSet dataset, boolean append, ParameterOption mode)
+    * @param    dataset
+    *           Reference of the wrapped dataset.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    * @param    input           
+    *           {@code true} if the parameter mode is INPUT or INPUT-OUTPUT.
+    * @param    output
+    *           {@code true} if the parameter mode is OUTPUT or INPUT-OUTPUT.
+    */     
+   public DataSetParameter(DataSet dataset, ParameterOption option, boolean input, boolean output)
    {
       this.originalDataSet = dataset;
-      this.dataset = new handle(dataset);
-      this.append = append;
-      this.mode = mode; // TODO: check default value for mode if ParameterOption.NONE is passed in
+      this.dataset         = new handle(dataset);
+      this.option          = option; // TODO: check default value for mode if ParameterOption.NONE is passed in
+      this.input           = input;
+      this.output          = output;
    }
    
    /**
     * Create an instance using a dataset handle.
     *
-    * @param   dsHandle
-    *          Handle to the wrapped dataset.
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
     */
    public DataSetParameter(handle dsHandle)
    {
-      this(dsHandle, false, ParameterOption.NONE);
+      this(dsHandle, ParameterOption.NONE);
    }
    
    /**
     * Create an instance using a dataset handle.
     *
-    * @param   dsHandle
-    *          Handle to the wrapped dataset.
-    * @param   append
-    *          Determines if APPEND option was specified on the calling side.
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
     */
-   public DataSetParameter(handle dsHandle, boolean append)
+   public DataSetParameter(handle dsHandle, ParameterOption option)
    {
-      this(dsHandle, append, ParameterOption.NONE);
+      this(dsHandle, option, false, false);
    }
    
    /**
     * Create an instance using a dataset handle.
     *
-    * @param   dsHandle
-    *          Handle to the wrapped dataset.
-    * @param   append
-    *          Determines if APPEND option was specified on the calling side.
-    * @param   mode
-    *          Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option.
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    * @param    input
+    *           {@code true} if the parameter mode is INPUT or INPUT-OUTPUT.
+    * @param    output
+    *           {@code true} if the parameter mode is OUTPUT or INPUT-OUTPUT.
     */
-   public DataSetParameter(handle dsHandle, boolean append, ParameterOption mode)
+   public DataSetParameter(handle dsHandle, ParameterOption option, boolean input, boolean output)   
    {
       this.dataset = dsHandle;
-      this.append = append;
-      this.mode = mode; // TODO: check default value for mode if ParameterOption.NONE is passed in
+      this.option  = option; // TODO: check default value for mode if ParameterOption.NONE is passed in
+      this.input   = input;
+      this.output  = output;
    }
 
    /**
@@ -257,8 +272,50 @@
    {
       return originalDataSet;
    }
+
+   /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   {@code true} if this is INPUT or INPUT-OUTPUT.
+    */
+   public boolean isInputMode()
+   {
+      return input;
+   }
+
+   /**
+    * Set the flag for whether this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @param    input
+    *           {@code true} if this is INPUT or INPUT-OUTPUT.
+    */
+   public void setInputMode(boolean input)
+   {
+      this.input = input;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   {@code true} if this is OUTPUT or INPUT-OUTPUT.
+    */
+   public boolean isOutputMode()
+   {
+      return output;
+   }
    
    /**
+    * Set the flag for whether this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @param    output
+    *           {@code true} if this is OUTPUT or INPUT-OUTPUT.
+    */
+   public void setOutputMode(boolean output)
+   {
+      this.output = output;
+   }
+
+   /**
     * Returns the unwrapped dataset instance.
     *
     * @return  see above.
@@ -281,11 +338,11 @@
    /**
     * Checks whether this parameter was passed with {@code APPEND} option.
     * 
-    * @return  {@code true} if this parameter was passed with {@code APPEND} option.
+    * @return   {@code true} if this parameter was passed with {@code APPEND} option.
     */
    public boolean isAppend()
    {
-      return append;
+      return option == ParameterOption.APPEND;
    }
    
    /**
@@ -295,7 +352,7 @@
     */
    public boolean isByReference()
    {
-      return mode == ParameterOption.BY_REFERENCE;
+      return option == ParameterOption.BY_REFERENCE;
    }
    
    /**
@@ -305,7 +362,7 @@
     */
    public boolean isByValue()
    {
-      return mode == ParameterOption.BY_VALUE;
+      return option == ParameterOption.BY_VALUE;
    }
    
    /**
@@ -315,7 +372,7 @@
     */
    public boolean isBind()
    {
-      return mode == ParameterOption.BIND;
+      return option == ParameterOption.BIND;
    }
    
    /**

=== added file 'src/com/goldencode/p2j/persist/InputDataSetHandle.java'
--- old/src/com/goldencode/p2j/persist/InputDataSetHandle.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/persist/InputDataSetHandle.java	2022-05-12 15:03:49 +0000
@@ -0,0 +1,166 @@
+/*
+** Module   : InputDataSetHandle.java
+** Abstract : INPUT DATASET-HANDLE parameter support
+**
+** Copyright (c) 2019-2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 GES 20210429 Created initial version, by moving code from the parent class.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+**
+** Additional terms under GNU Affero GPL version 3 section 7:
+**
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+**
+**   0. Attribution Requirement.
+**
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+**
+**   1. No License To Use Trademarks.
+**
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+**
+**   2. No Misrepresentation of Affiliation.
+**
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+**
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+**
+**   3. No Misrepresentation of Source or Origin.
+**
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.persist;
+
+import com.goldencode.p2j.util.*;
+
+import java.util.*;
+
+/**
+ * Implements the INPUT DATASET-HANDLE parameter type. This hard codes the input/output flags and delegates
+ * all other processing to the parent class.
+ */
+public class InputDataSetHandle
+extends DataSetParameter
+{
+   /**
+    * Create a new parameter for the REMOTE dataset.
+    * 
+    * @param    wrapper
+    *           The REMOTE dataset.
+    */
+   public InputDataSetHandle(DatasetWrapper wrapper)
+   {
+      super(wrapper);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public InputDataSetHandle(InputDataSetHandle dataset)
+   {
+      super(dataset.getDataset(), ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public InputDataSetHandle(DataSet dataset)
+   {
+      super(dataset, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    * @param   option
+    *          Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputDataSetHandle(DataSet dataset, ParameterOption option)
+   {
+      super(dataset, option);
+   }
+      
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    */
+   public InputDataSetHandle(handle dsHandle)
+   {
+      super(dsHandle, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputDataSetHandle(handle dsHandle, ParameterOption option)
+   {
+      super(dsHandle, option);
+   }
+   
+   /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   public boolean isInputMode()
+   {
+      return true;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code false}.
+    */
+   public boolean isOutputMode()
+   {
+      return false;
+   }
+}

